<?php namespace MapGuesser\Controller;

use SokoWeb\Interfaces\Response\IContent;
use SokoWeb\Interfaces\Response\IRedirect;
use SokoWeb\Response\JsonContent;
use SokoWeb\Response\Redirect;

class HomeController
{
    public function getIndex(): IRedirect
    {
        return new Redirect(\Container::$routeCollection->getRoute('maps')->generateLink(), IRedirect::TEMPORARY);
    }

    public function startSession(): IContent
    {
        // session starts with the request, this method just sends valid data to the client

        return new JsonContent(['antiCsrfToken' => \Container::$request->session()->get('anti_csrf_token')]);
    }
}
